; $Id: grep.pro,v 1.3 2012/06/20 21:00:15 kneller Exp $


pro grep,fn,str,i=i,l=l,arr=arr,exclusive=exclusive,output=output,fullpath=fullpath

  if n_elements(i) eq 0 then i = 1
  if n_elements(l) eq 0 then l = 0
  if n_elements(exclusive) eq 0 then exclusive = 0
  if n_elements(fullpath) eq 0 then fullpath = 0 
  output = ['']

  ;arr v. file
  if n_elements(arr) gt 0 then begin
  
      ;SEARCH THROUGH A STRING ARRAY.
      print,'In String Array:'
      nlines=n_elements(arr)
      line = ''
      for j=0,nlines-1 do begin
        line = arr[j]
        if stregex(line,str,/boolean,fold_case=i) eq 1 then begin
          if l eq 0 then print,line else print,strtrim(string(j),2)+': '+line
        endif
      endfor;j
  
  endif else begin

    ;SEARCH THROUGH A FILE
      if n_elements(fn) eq 0 then begin
        print,'No file entered.'
        return
      endif
      if n_elements(str) eq 0 then begin
        print,'No file entered.'
        return
      endif
      
      for ifn = 0,n_elements(fn)-1 do begin
          if file_test(fn[ifn]) gt 0 then begin
            if file_test(fn[ifn],/directory) eq 0 then begin
                if exclusive eq 0 then begin
                  if fullpath eq 0 then begin
                    print,'In '+file_basename(fn[ifn])+':'
                  endif else begin
                    print,'In '+fn[ifn]+':'
                  endelse
                  nlines=file_lines(fn[ifn])
                  
                  line = ''
                  openr,lun,fn[ifn],/get_lun
                  for j=0,nlines-1 do begin
                    readf,lun,line
                    if stregex(line,str,/boolean,fold_case=i) eq 1 then begin
                      if l eq 0 then print,line else print,strtrim(string(j),2)+': '+line
                    endif
                  endfor;j
                  free_lun,lun
                endif else begin
                  ;EXCLUSIVE - ONLY PRINT WHEN THERE IS A MATCH
                  nlines=file_lines(fn[ifn])
                  
                  line = ''
                  openr,lun,fn[ifn],/get_lun
                  for j=0,nlines-1 do begin
                    readf,lun,line
                    if stregex(line,str,/boolean,fold_case=i) eq 1 then begin
                      if l eq 0 then begin
                        if fullpath eq 0 then begin
                          s2print = 'In '+file_basename(fn[ifn])+': '+line
                        endif else begin
                          s2print = 'In '+fn[ifn]+': '+line
                        endelse
                      endif else begin
                        if fullpath eq 0 then begin
                          s2print = 'In '+file_basename(fn[ifn])+': at line '+strtrim(string(j),2)+': '+line
                        endif else begin
                          s2print = 'In '+fn[ifn]+': at line '+strtrim(string(j),2)+': '+line
                        endelse
                        ;print,'In '+file_basename(fn[ifn])+': at line '+strtrim(string(j),2)+': '+line
                      endelse
                      print,s2print
                      output = [output,s2print]
                    endif
                  endfor;j
                  free_lun,lun
                endelse
            endif else begin
              if exclusive eq 0 then begin
                print,'!!!!!!!!!   WARNING: '+fn[ifn]+' is a directory.    !!!!!!!!!'
              endif
            endelse
          endif else begin
            if exclusive eq 0 then begin 
              if fullpath eq 0 then begin
                ;print,'!!!!!!!!!   File not available:   '+file_basename(fn[ifn])+'    !!!!!!!!!'
              endif else begin
                ;print,'!!!!!!!!!   File not available:   '+fn[ifn]+'    !!!!!!!!!'
              endelse
            endif
          endelse
      endfor

  endelse;FILE


end;grep
; $Id: grep.pro,v 1.3 2012/06/20 21:00:15 kneller Exp $
;
;
;pro grep,fn,str,i=i,l=l,arr=arr,exclusive=exclusive,output=output,fullpath=fullpath
;
;  if n_elements(i) eq 0 then i = 1
;  if n_elements(l) eq 0 then l = 0
;  if n_elements(exclusive) eq 0 then exclusive = 0 
;  if n_elements(fullpath) eq 0 then fullpath = 0
;
;  output = ['']
;
;  ;arr v. file
;  if n_elements(arr) gt 0 then begin
;  
;      ;SEARCH THROUGH A STRING ARRAY.
;      print,'In String Array:'
;      nlines=n_elements(arr)
;      line = ''
;      for j=0,nlines-1 do begin
;        line = arr[j]
;        if stregex(line,str,/boolean,fold_case=i) eq 1 then begin
;          if l eq 0 then print,line else print,strtrim(string(j),2)+': '+line
;        endif
;      endfor;j
;  
;  endif else begin
;
;    ;SEARCH THROUGH A FILE
;      if n_elements(fn) eq 0 then begin
;        print,'No file entered.'
;        return
;      endif
;      if n_elements(str) eq 0 then begin
;        print,'No file entered.'
;        return
;      endif
;      
;      for ifn = 0,n_elements(fn)-1 do begin
;          if file_test(fn[ifn]) gt 0 then begin
;            if file_test(fn[ifn],/directory) eq 0 then begin
;                if exclusive eq 0 then begin
;                  print,'In '+file_basename(fn[ifn])+':'
;                  nlines=file_lines(fn[ifn])
;                  
;                  line = ''
;                  openr,lun,fn[ifn],/get_lun
;                  for j=0,nlines-1 do begin
;                    readf,lun,line
;                    if stregex(line,str,/boolean,fold_case=i) eq 1 then begin
;                      if l eq 0 then print,line else print,strtrim(string(j),2)+': '+line
;                    endif
;                  endfor;j
;                  free_lun,lun
;                endif else begin
;                  ;EXCLUSIVE - ONLY PRINT WHEN THERE IS A MATCH
;                  ;print,'In '+file_basename(fn[ifn])+':'
;                  nlines=file_lines(fn[ifn])
;                  
;                  line = ''
;                  openr,lun,fn[ifn],/get_lun
;                  for j=0,nlines-1 do begin
;                    readf,lun,line
;                    if stregex(line,str,/boolean,fold_case=i) eq 1 then begin
;                      if l eq 0 then begin
;                        s2print = 'In '+file_basename(fn[ifn])+': '+line
;                        ;print,'In '+file_basename(fn[ifn])+': '+line 
;                      endif else begin
;                        s2print = 'In '+file_basename(fn[ifn])+': at line '+strtrim(string(j),2)+': '+line
;                        ;print,'In '+file_basename(fn[ifn])+': at line '+strtrim(string(j),2)+': '+line
;                      endelse
;                      print,s2print
;                      output = [output,s2print]
;                    endif
;                  endfor;j
;                  free_lun,lun
;                endelse
;            endif else begin
;              if exclusive eq 0 then begin
;                print,'!!!!!!!!!   WARNING: '+fn[ifn]+' is a directory.    !!!!!!!!!'
;              endif
;            endelse
;          endif else begin
;            if exclusive eq 0 then begin 
;              print,'!!!!!!!!!   File not available:   '+file_basename(fn[ifn])+'    !!!!!!!!!'
;            endif
;          endelse
;      endfor
;
;  endelse;FILE
;
;
;end;grep
