; $Id: macs_plotslice_dpmod.pro,v 1.1 2010/03/24 16:02:42 kneller Exp $



pro macs_plotslice_dpmod,xi,yi,zi,avhw,ncg=ncg,ps=ps,_extra=_extra,pos=pos,filename=filename
;-----------------------------------------------------------------------------------
;   ncg: pixel side length of averaging area
;   file: Name of output normalization file
;   ps: set to 1 for post script output
;   _extra: transfer additional keywords to plotsq routine
;------------------------------------------------------------------------------------

if n_elements(ncg) eq 1 then zo = macs_cgrain(zi,ncg,ncg,white=white) else zo=zi


;--------------------
; actual plotting
;--------------------
if keyword_set(ps) then begin
  mydevice = !D.NAME 
  set_plot,'ps'
  device,/color,xsize=30,ysize=20,yoff=5,filename=filename
  loadct,4
  plotsq_dpmod,zo,xi,yi,white=white,xtit='!6Q!dx!n (!sA!r!e!u!9%!6-1!n)',ytit='!6Q!dy!n (!sA!r!e!u!9%!6-1!n)' $
    ,tit='!6!s!8h!r!e!u!3_!n !7x!6='+string(avhw,form='(f5.2)')+' meV',pos=pos,_extra=_extra
  device,/close
  SET_PLOT, mydevice
end else $
   plotsq_dpmod,zo,xi,yi,white=white,xtit='!6Q!dx!n (!sA!r!e!u!9%!6-1!n)',ytit='!6Q!dy!n (!sA!r!e!u!9%!6-1!n)'   $
          ,tit='!6!s!8h!r!e!u!3_!n !7x!6='+string(avhw,form='(f5.2)')+' meV',_extra=_extra,pos=pos;,pos=[.15,.15,.85,.9],_extra=_extra

end;macs_plotslice_dpmod

