; $Id: vmacs_mslice.pro,v 1.4 2011/03/16 17:39:15 kneller Exp $
@dcs_mslice
pro vMACS_mslice, rint, drint, x, y, z=z, label=label, unit=unit, title=title, $
                  dataPtr=dataPtr,group_leader=group_leader,$
                  workDir=workDir,dataDir=dataDir,DAVETool=DAVETool,$
                  obj_mslice=obj_mslice,$
                  _Extra=extra

;ADDING ALL THE KEYWORDS FOR THE MSLICE CALL.
;AT THIS POINT, IF obj_mslice IS ALREADY VALID, THEN I WILL
;USE THE ::rest_data METHOD TO UPDATE THE EXISTING DATA
;IF obj_mslice IS NOT ALREADY VALID, I WILL CREATE A NEW ONE 
;WHICH WILL BE AVAILABLE VIA THE KEYWORD.


                
   if n_elements(title) eq 0 then title = ''
   if keyword_set(z) then begin 
      data = [[rint], [drint], [x], [y], [z]]
      is_uniq = [0,0,0,0,1]
      if not keyword_set(label) then label  = ['I', 'dI', 'H', 'K', 'hw']
      if not keyword_set(unit)  then unit   = ['Counts', 'Counts', 'r.l.u.', 'r.l.u.', 'meV']
   endif $
   else begin 
      data = [[rint], [drint], [x], [y]]
      is_uniq = [0,0,0,0]
      if not keyword_set(label) then label  = ['I', 'dI', 'H', 'K']
      if not keyword_set(unit)  then unit   = ['Counts', 'Counts', 'r.l.u.', 'r.l.u.']
   endelse
   instrument = 'MACS-1: '+title
   dataPtr = ptr_new({data:data, label:label, unit:unit, instrument:instrument, is_uniq:is_uniq})
   
   ;obj_mslice = obj_new('dcs_mslice', dataPtr=dataPtr)   
   if n_elements(obj_mslice) eq 0 then begin
     obj_mslice = obj_new('dcs_mslice', dataPtr=dataPtr, $
                            group_leader=group_leader,$
                            workDir=workDir,dataDir=dataDir,DAVETool=DAVETool)
   endif else begin
     if obj_valid(obj_mslice) gt 0 then begin
       obj_mslice->reset_data,data=data,label=label,instrument=instrument,is_uniq=is_uniq;,$
                             ;author=author,unit=unit,no_copy=no_copy
     endif else begin
      obj_mslice = obj_new('dcs_mslice', dataPtr=dataPtr, $
                            group_leader=group_leader,$
                            workDir=workDir,dataDir=dataDir,DAVETool=DAVETool)
     endelse
   endelse
   
   
end;vMACS_mslice

